//
// NT100E3-1 clock profiles
//
// Si5338 Clock profiles (with history of changes)
//

#ifndef __NT100E3_1_CLOCK_PROFILES_H__
#define __NT100E3_1_CLOCK_PROFILES_H__


//
// Include setup data from two data files
// It is necessary to prevent clashes between names and definitions
//

//
// NT100E3-1: Si5338: U18
//
//  Changelog:
//
// "NT100E3-1_U18_Si5338_adr0_v2.h" // XX: 20140411: v2: initial
// "NT100E3-1_U18_Si5338_adr0_v3.h" // UJ: 20141117: v3: NSEB clock change: 156.25->206.25 MHz - currently only used by production test images - profile includes frequency stepping feature
// "NT100E3-1_U18_Si5338_adr0_v4.h" // UJ: 20150313: v4: NSEB clock change: 206.25->342.424 MHz - disable all clock outputs - no frequency stepping feature
// "NT100E3-1_U18_Si5338_adr0_v5.h" // UJ: 20150511: v5: DDR3 clock change: 233.33->225MHz - disable all clock outputs - no frequency stepping feature
//

#define code

#define Reg_Data Reg_Data_NT100E3_1_U18_v2
#define Reg_Store Data_Si5338_NT100E3_1_U18_v2
#include "NT100E3-1_U18_Si5338_adr0_v2.h" // XX: 20140411: v2: initial
#undef Reg_Store
#undef Reg_Data

#define Reg_Data Reg_Data_NT100E3_1_U18_v3
#define Reg_Store Data_Si5338_NT100E3_1_U18_v3
#include "NT100E3-1_U18_Si5338_adr0_v3.h" // UJ: 20141117: v3: NSEB clock change: 156.25->206.25 MHz - currently only used by production test images - profile includes frequency stepping feature
#undef Reg_Store
#undef Reg_Data

#define Reg_Data Reg_Data_NT100E3_1_U18_v4
#define Reg_Store Data_Si5338_NT100E3_1_U18_v4
#include "NT100E3-1_U18_Si5338_adr0_v4.h" // UJ: 20150313: v4: NSEB clock change: 206.25->342.424 MHz - disable all clock outputs - no frequency stepping feature
#undef Reg_Store
#undef Reg_Data

#define Reg_Data Reg_Data_NT100E3_1_U18_v5
#define Reg_Store Data_Si5338_NT100E3_1_U18_v5
#include "NT100E3-1_U18_Si5338_adr0_v5.h" // UJ: 20150511: v5: DDR3 clock change: 233.33->225MHz - disable all clock outputs - no frequency stepping feature
#undef Reg_Store
#undef Reg_Data

#undef code

//
// NT100E3-1: Si5338: U116
//
//  Changelog:
//
// "NT100E3-1_U116_Si5338_adr1_v4.h" // UJ: 20140306: v4: Si5338 (U116) input clock switched from IN1/2 to IN5/6 (external feedback clock input pins)
// "NT100E3-1_U116_Si5338_adr1_v5.h" // UJ: 20140422: v5: Si5338 (U116) New 312,5MHz FPGA MAC clock (on CLK3 clock output)
// "NT100E3-1_U116_Si5338_adr1_v6.h" // UJ: 20140425: v6: Si5338 (U116) HCSL on output 0, disable output 2
// "NT100E3-1_U116_Si5338_adr1_v7.h" // UJ: 20140521: v7: Si5338 (U116) re-enable output 2
//

#define code

#define Reg_Data Reg_Data_NT100E3_1_U116_v4
#define Reg_Store Data_Si5338_NT100E3_1_U116_v4
#include "NT100E3-1_U116_Si5338_adr1_v4.h" // UJ: 20140306: v4: Si5338 (U116) input clock switched from IN1/2 to IN5/6 (external feedback clock input pins)
#undef Reg_Store
#undef Reg_Data

#define Reg_Data Reg_Data_NT100E3_1_U116_v5
#define Reg_Store Data_Si5338_NT100E3_1_U116_v5
#include "NT100E3-1_U116_Si5338_adr1_v5.h" // UJ: 20140422: v5: Si5338 (U116) New 312,5MHz FPGA MAC clock (on CLK3 clock output)
#undef Reg_Store
#undef Reg_Data

#define Reg_Data Reg_Data_NT100E3_1_U116_v6
#define Reg_Store Data_Si5338_NT100E3_1_U116_v6
#include "NT100E3-1_U116_Si5338_adr1_v6.h" // UJ: 20140425: v6: Si5338 (U116) HCSL on output 0, disable output 2
#undef Reg_Store
#undef Reg_Data

#define Reg_Data Reg_Data_NT100E3_1_U116_v7
#define Reg_Store Data_Si5338_NT100E3_1_U116_v7
#include "NT100E3-1_U116_Si5338_adr1_v7.h" // UJ: 20140521: v7: Si5338 (U116) re-enable output 2
#undef Reg_Store
#undef Reg_Data

#undef code

//
//
//

#endif // __NT100E3_1_CLOCK_PROFILES_H__

//
// EOF
//
