//
// NT40E3-4 clock profiles
//
// Si5338 Clock profiles (with history of changes)
//

#ifndef __NT40E3_4_CLOCK_PROFILES_H__
#define __NT40E3_4_CLOCK_PROFILES_H__


//
// Include setup data from two data files
// It is necessary to prevent clashes between names and definitions
//

//
// NT40E3-4: Si5338: U18
//
//
// Changelog:
//
// "NT40E3-4_U18_SI5338_v4.h" // UJ: 20130228: v4: (includes *NO* frequency stepping feature)
//

#define code

#define Reg_Data Reg_Data_NT40E3_4_U18_v4
#define Reg_Store Data_Si5338_NT40E3_4_U18_v4
#include "NT40E3-4_U18_SI5338_v4.h" // UJ: 20130228: v4: (includes *NO* frequency stepping feature)
#undef Reg_Store
#undef Reg_Data

#define Reg_Data Reg_Data_NT40E3_4_U18_v7
#define Reg_Store  Data_Si5338_NT40E3_4_U18_v7
//PHT:20150122: V7:
  //NO frequency stepping feature
  //Output clock 1 frequency 50MHz -> 125MHz
  //Output clock 3 frequency 156.25MHz -> 206.25MHz (for NSEB - not used here)
  //Driver 0,1,2,3 default disabled - must be enabled by SW
#include "NT40E3-4_U18_SI5338_v7.h"
#undef Reg_Store
#undef Reg_Data

#define Reg_Data Reg_Data_NT40E3_4_U18_v7B
#define Reg_Store  Data_Si5338_NT40E3_4_U18_v7B
//APN:20200122: V7B:
  // Copied from V7 with the following change:
  // Output clock 0 frequency 233MHz -> 200MHz (DDR from 1866 to 1600)
#include "NT40E3-4_U18_SI5338_v7B.h"
#undef Reg_Store
#undef Reg_Data

#define Reg_Data Reg_Data_NT40E3_4_U18_v8
#define Reg_Store  Data_Si5338_NT40E3_4_U18_v8
//JBC: V8:
  //Output clock 3 frequency 206.25MHz -> 342.45MHz (for NSEB)
#include "NT40E3-4_U18_SI5338_v8.h"
#undef Reg_Store
#undef Reg_Data

#undef code

//
//
//

#endif // __NT40E3_4_CLOCK_PROFILES_H__

//
// EOF
//
