/* SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef __NTHW_II2CM_H__
#define __NTHW_II2CM_H__


#include "nthw_fpga_model.h"
#include "pthread.h"


struct nt_i2cm {
  nthw_fpga_t* mpFpga;

  nthw_module_t* mModI2cm;

  int mnI2cInstance;

  nthw_register_t* mpRegPrerLow;
  nthw_field_t*    mpFldPrerLowPrerLow;

  nthw_register_t* mpRegPrerHigh;
  nthw_field_t*    mpFldPrerHighPrerHigh;

  nthw_register_t* mpRegCtrl;
  nthw_field_t*    mpFldCtrlIen;
  nthw_field_t*    mpFldCtrlEn;

  nthw_register_t* mpRegData;
  nthw_field_t*    mpFldDataData;

  nthw_register_t* mpRegCmdStatus;
  nthw_field_t*    mpFldCmdStatusCmdStatus;

  nthw_register_t* mpRegSelect;
  nthw_field_t*    mpFldSelectSelect;

  nthw_register_t* mpRegIoExp;
  nthw_field_t*    mpFldIoExpRst;
  nthw_field_t*    mpFldIoExpIntB;

  pthread_mutex_t i2cmmutex;
};

typedef struct nt_i2cm nthw_i2cm_t;
typedef struct nt_i2cm nt_i2cm;


nthw_i2cm_t* nthw_i2cm_new(void);
int nthw_i2cm_init(nthw_i2cm_t *p, nthw_fpga_t *pFpga, int nI2cInstance);
int nthw_i2cm_read(nthw_i2cm_t *p, uint8_t devAddr, uint8_t regAddr, uint8_t *value);
int nthw_i2cm_read16(nthw_i2cm_t *p, uint8_t devAddr, uint8_t regAddr, uint16_t *value);
int nthw_i2cm_write(nthw_i2cm_t *p, uint8_t devAddr, uint8_t regAddr, uint8_t value);
int nthw_i2cm_write16(nthw_i2cm_t *p, uint8_t devAddr, uint8_t regAddr, uint16_t value);

#endif /* __NTHW_II2CM_H__ */
