/* SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef NTHW_MAC_RX_H_
#define NTHW_MAC_RX_H_

struct NthwMacRx
{
  nthw_fpga_t* mpFpga;
  nthw_module_t* mpModMacRx;
  int mnInstance;

  uint32_t mFirstValue;
  uint32_t mLarstValue;
  uint64_t mAddValue;
  bool mFirstTime;

  nthw_field_t* mpFldBadFcsCount;

  nthw_field_t* mpFldTotalPacketsCount;
  nthw_field_t* mpFldTotalGoodPacketsCount;

  nthw_field_t* mpFldPacketSmallCount;

  nthw_field_t* mpFldTotalBytesCount;
  nthw_field_t* mpFldTotalGoodBytesCount;

  nthw_field_t* mpFldPacketBadFcsCount;
  nthw_field_t* mpFldUndersizeCount;

};

typedef struct NthwMacRx NthwMacRx_t;
typedef struct NthwMacRx NthwMacRx;

NthwMacRx_t* NthwMacRx_new(void);
void NthwMacRx_delete(NthwMacRx_t* p);
int NthwMacRx_init(NthwMacRx_t *p, nthw_fpga_t* pFpga, int nInstance);

uint64_t NthwMacRx_getBadFcsCount(NthwMacRx_t* p);
uint64_t NthwMacRx_getTotalBytesCount(NthwMacRx_t* p);
uint64_t NthwMacRx_getTotalGoodBytesCount(NthwMacRx_t* p);
uint64_t NthwMacRx_getTotalPacketsCount(NthwMacRx_t* p);
uint64_t NthwMacRx_getTotalGoodPacketsCount(NthwMacRx_t* p);
uint64_t NthwMacRx_getPacketSmallCount(NthwMacRx_t* p);
uint64_t NthwMacRx_getPacketBadFcsCount(NthwMacRx_t* p);
uint64_t NthwMacRx_getRxUndersizeCount(NthwMacRx_t* p);

#endif /* NTHW_MAC_RX_H_ */
