/* SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef NTHW_MAC_TX_H_
#define NTHW_MAC_TX_H_

struct NthwMacTx
{
  nthw_fpga_t* mpFpga;
  nthw_module_t* mpModMacTx;
  int mnInstance;

  uint32_t mFirstValue;
  uint32_t mLarstValue;
  uint64_t mAddValue;
  bool mFirstTime;

  nthw_field_t* mpFldTotalPacketsCount;
  nthw_field_t* mpFldTotalGoodPacketsCount;

  nthw_field_t* mpFldPacketSmallCount;

  nthw_field_t* mpFldTotalBytesCount;
  nthw_field_t* mpFldTotalGoodBytesCount;
};

typedef struct NthwMacTx NthwMacTx_t;
typedef struct NthwMacTx NthwMacTx;

NthwMacTx_t* NthwMacTx_new(void);
void NthwMacTx_delete(NthwMacTx_t* p);
int NthwMacTx_init(NthwMacTx_t *p, nthw_fpga_t* pFpga, int nInstance);

uint64_t NthwMacTx_getBadFcsCount(NthwMacTx_t* p);
uint64_t NthwMacTx_getTotalBytesCount(NthwMacTx_t* p);
uint64_t NthwMacTx_getTotalGoodBytesCount(NthwMacTx_t* p);
uint64_t NthwMacTx_getTotalPacketsCount(NthwMacTx_t* p);
uint64_t NthwMacTx_getTotalGoodPacketsCount(NthwMacTx_t* p);
uint64_t NthwMacTx_getPacketSmallCount(NthwMacTx_t* p);
uint64_t NthwMacTx_getPacketBadFcsCount(NthwMacTx_t* p);

#endif /* NTHW_MAC_TX_H_ */
