/* SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef __NTHW_PCA9532_H__
#define __NTHW_PCA9532_H__

#include "nthw_si5332_si5156.h"

struct NthwPca9532 {
  nthw_i2cm_t* mp_nt_i2cm;
  uint8_t m_dev_address;
  nthw_pca9849_t *mpCA9849;
  uint8_t m_mux_channel;
};

typedef struct NthwPca9532 nthw_pca9532_t;

nthw_pca9532_t* NthwPca9532_new(void);
void NthwPca9532_delete(nthw_pca9532_t* p);
int NthwPca9532_init(nthw_pca9532_t* p, nthw_i2cm_t* p_nt_i2cm, uint8_t devAddress, nthw_pca9849_t *pca9849, uint8_t muxChannel);
void NthwPca9532_setLedOn(nthw_pca9532_t* p, uint8_t ledPos, bool stateOn);

#endif /* __NTHW_PCA9532_H__ */
