/* SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */
#ifndef __NTHW_PCAL6416A_H__
#define __NTHW_PCAL6416A_H__

#include "nthw_si5332_si5156.h"

/*****************************************************************************/
/*                                PCAL6416A I/O expander class               */
/*****************************************************************************/

struct NthwPcal6416a {
  nthw_i2cm_t* mp_nt_i2cm;
  uint8_t m_dev_address;
  nthw_pca9849_t *mpCA9849;
  uint8_t m_mux_channel;
  uint8_t mConfigData[2];
};

typedef struct NthwPcal6416a nthw_pcal6416a_t;

nthw_pcal6416a_t* NthwPcal6416a_new(void);
int NthwPcal6416a_init(nthw_pcal6416a_t* p, nthw_i2cm_t* p_nt_i2cm, uint8_t devAddress, nthw_pca9849_t *pca9849, uint8_t muxChannel);
void NthwPcal6416a_delete(nthw_pcal6416a_t* p);
void NthwPcal6416a_write(nthw_pcal6416a_t* p, uint8_t pin, uint8_t value);
void NthwPcal6416a_read(nthw_pcal6416a_t* p, uint8_t pin, uint8_t *value);

#endif /* __NTHW_PCAL6416A_H__ */
