/* SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef __NTHW_PCI_TA_H__
#define __NTHW_PCI_TA_H__

struct NthwPciTa
{
  nthw_fpga_t* mpFpga;
  nthw_module_t* mpModPciTa;
  int mnInstance;

  int mnParamPciTaTgPresent;

  nthw_register_t* mpRegPciTaCtrl;
  nthw_field_t* mpFldPciTaCtrlEnable;
  nthw_register_t* mpRegPciTaPacketGood;
  nthw_field_t* mpFldPciTaPacketGoodAmount;
  nthw_register_t* mpRegPciTaPacketBad;
  nthw_field_t* mpFldPciTaPacketBadAmount;
  nthw_register_t* mpRegPciTaLengthError;
  nthw_field_t* mpFldPciTaLengthErrorAmount;
  nthw_register_t* mpRegPciTaPayloadError;
  nthw_field_t* mpFldPciTaPayloadErrorAmount;
};

typedef struct NthwPciTa NthwPciTa_t;
typedef struct NthwPciTa NthwPciTa;

NthwPciTa_t* NthwPciTa_new(void);
void NthwPciTa_delete(NthwPciTa_t* p);
int NthwPciTa_init(NthwPciTa_t* p, nthw_fpga_t* pFpga, int nInstance);

void NthwPciTa_setControlEnable(NthwPciTa_t* p, uint32_t val);
void NthwPciTa_getPacketGood(NthwPciTa_t* p, uint32_t* val);
void NthwPciTa_getPacketBad(NthwPciTa_t* p, uint32_t* val);
void NthwPciTa_getLengthError(NthwPciTa_t* p, uint32_t* val);
void NthwPciTa_getPayloadError(NthwPciTa_t* p, uint32_t* val);

#endif /* __NTHW_PCI_TA_H__ */
