/* SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */
#ifndef __NTHW_PCM_NT400DXX_H__
#define __NTHW_PCM_NT400DXX_H__

struct NthwPcm_NT400DXX
{
  nthw_fpga_t* mpFpga;
  nthw_module_t* mpModPcm;
  int mnInstance;

  int mnModuleMajorVersion;
  int mnModuleMinorVersion;

  nthw_register_t* mpRegCtrl;
  nthw_field_t* mpFldCtrlTsPllRecal; /* Dunite HW version 3 */
  nthw_field_t* mpFldCtrlTsClksel;
  nthw_field_t* mpFldCtrlTsPllRst;

  nthw_register_t* mpRegStat;
  nthw_field_t* mpFldStatTsPllLocked;

  nthw_register_t* mpRegLatch;
  nthw_field_t* mpFldLatchTsPllLocked;
};

typedef struct NthwPcm_NT400DXX nthw_pcm_nt400dxx_t;
typedef struct NthwPcm_NT400DXX NthwPcm_NT400DXX;

nthw_pcm_nt400dxx_t* NthwPcm_nt400dxx_new(void);
void NthwPcm_nt400dxx_delete(nthw_pcm_nt400dxx_t* p);
int NthwPcm_nt400dxx_init(nthw_pcm_nt400dxx_t* p, nthw_fpga_t* pFpga, int nInstance);
void NthwPcm_nt400dxx_set_ts_pll_recal(nthw_pcm_nt400dxx_t* p, uint32_t val);
bool NthwPcm_nt400dxx_get_ts_pll_locked_stat(nthw_pcm_nt400dxx_t* p);
bool NthwPcm_nt400dxx_get_ts_pll_locked_latch(nthw_pcm_nt400dxx_t* p);
void NthwPcm_nt400dxx_set_ts_pll_locked_latch(nthw_pcm_nt400dxx_t* p, uint32_t val);

#endif /* __NTHW_PCM_NT400DXX_H__ */
