/* SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef NTHW_PRM_NT50B01_V01_H_
#define NTHW_PRM_NT50B01_V01_H_

struct NthwPrm_nt50b01_v1
{
  nthw_fpga_t* mpFpga;
  nthw_module_t* mpModPrm;
  int mnInstance;

  nthw_register_t* mpRegRst;
  nthw_field_t* mpFldRstPeriph;
  nthw_field_t* mpFldRstPlatform;

  nthw_register_t* mpRegPower;
  nthw_field_t* mpFldPowerPuPhy;
  nthw_field_t* mpFldPowerPuNseb;
};

typedef struct NthwPrm_nt50b01_v1 NthwPrm_nt50b01_v1_t;
typedef struct NthwPrm_nt50b01_v1 NthwPrm_nt50b01_v1;

NthwPrm_nt50b01_v1_t* NthwPrm_nt50b01_v1_new(void);
void NthwPrm_nt50b01_v1_delete(NthwPrm_nt50b01_v1_t* p);
int NthwPrm_nt50b01_v1_init(NthwPrm_nt50b01_v1_t* p, nthw_fpga_t* pFpga, int nInstance);

#endif /* NTHW_PRM_NT50B01_V01_H_ */
