/* SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef __NTHW_SDC_H__
#define __NTHW_SDC_H__

struct NthwSdc
{
  nthw_fpga_t* mpFpga;
  nthw_module_t* mpModSdc;
  int mnInstance;

  nthw_field_t* mpFldCtrlInit;
  nthw_field_t* mpFldCtrlRunTest;
  nthw_field_t* mpFldCtrlStopClient;
  nthw_field_t* mpFldCtrlTestEnable;

  nthw_field_t* mpFldStatCalib;
  nthw_field_t* mpFldStatCellCntStopped;
  nthw_field_t* mpFldStatErrFound;
  nthw_field_t* mpFldStatInitDone;
  nthw_field_t* mpFldStatMmcmLock;
  nthw_field_t* mpFldStatPllLock;
  nthw_field_t* mpFldStatResetting;

  nthw_field_t* mpFldCellCnt;
  nthw_field_t* mpFldCellCntPeriod;
  nthw_field_t* mpFldFillLEvel;
  nthw_field_t* mpFldMaxFillLevel;
};

typedef struct NthwSdc NthwSdc_t;
typedef struct NthwSdc NthwSdc;

NthwSdc_t* NthwSdc_new(void);
int NthwSdc_init(NthwSdc_t* p, nthw_fpga_t* pFpga, int nInstance);
void NthwSdc_delete(NthwSdc_t* p);

int NthwSdc_WaitStates(NthwSdc_t* p, const int nPollIterations, const int nPollInterval);
int NthwSdc_GetStates(NthwSdc_t* p, uint64_t* pnResultMask);

#endif /* __NTHW_SDC_H__ */
