/* SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef __NTHW_SI5340_H__
#define __NTHW_SI5340_H__

#include "nthw_clock_profiles.h"

#define SI5340_SUCCESS (0)
#define SI5340_FAILED  (999)
#define SI5340_TIMEOUT (666)

struct NthwSi5340
{
  uint8_t mnIicAddr;
  NthwIic_t* mpNthwIic;
  int mnClkCfg;
  uint8_t mSi5340_Page;
};

typedef struct NthwSi5340 NthwSi5340_t;

NthwSi5340_t* NthwSi5340_new(void);
int NthwSi5340_init(NthwSi5340_t *p, NthwIic_t *pNthwIic, uint8_t nIicAddr);
void NthwSi5340_delete(NthwSi5340_t* p);

#if 0
int NthwSi5340_config(NthwSi5340_t* p, const Si5340Data_t* pData, int dataCnt, uint8_t clkSrc, int clkCfg);
#endif
int NthwSi5340_config(NthwSi5340_t* p, const void* pData, int dataCnt, clkProfileDataFmt_t dataFormat);
int NthwSi5340_configFmt1(NthwSi5340_t* p, const clkProfileDataFmt1_t* pData, const int dataCnt);
int NthwSi5340_configFmt2(NthwSi5340_t* p, const clkProfileDataFmt2_t* pData, const int dataCnt);
#if 0
uint8_t NthwSi5340_read(NthwSi5340_t* p, uint16_t RegAddr);
int NthwSi5340_write(NthwSi5340_t* p, uint16_t RegAddr, uint8_t data);
#endif

#endif /* __NTHW_SI5338_H__ */
