/* SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef __FLOW_NTHW_RPP_LR_H__
#define __FLOW_NTHW_RPP_LR_H__

#include <stdint.h>
#include "nthw_fpga_model.h"

struct RppLrNthw {
  uint8_t mPhysicalAdapterNo;
  nthw_fpga_t *mpFpga;

  nthw_module_t *mRppLr;

  nthw_register_t *mpRcpCtrl;
  nthw_field_t *mpRcpAddr;
  nthw_field_t *mpRcpCnt;

  nthw_register_t *mpRcpData;
  nthw_field_t *mpRcpDataExp;

  nthw_register_t *mpIfrRcpCtrl;
  nthw_field_t *mpIfrRcpAddr;
  nthw_field_t *mpIfrRcpCnt;

  nthw_register_t *mpIfrRcpData;
  nthw_field_t *mpIfrRcpDataEn;
  nthw_field_t *mpIfrRcpDataMtu;
};

struct RppLrNthw *RppLrNthw_new(void);
void RppLrNthw_delete(struct RppLrNthw *p);
int RppLrNthw_init(struct RppLrNthw *p, nthw_fpga_t *pFpga, int nInstance);

int RppLrNthw_setup(struct RppLrNthw *p, int nIdx, int nIdxCnt);
void rppLrNthw_setDebugMode(struct RppLrNthw *p, unsigned int nDebugMode);

#if 0
  uint32_t GetVersionMajor(void) {return (mRppLr.getVersion()).getMajorVersion();}
  uint32_t GetVersionMinor(void) {return (mRppLr.getVersion()).getMinorVersion();}
  void SetDebugOutput(int on) {if (on) mRppLr.setDebugMode(Register::ON_WRITE); else mRppLr.setDebugMode(Register::NO_DEBUG);}
#endif

/* RCP */
void RppLrNthw_RcpSelect(const struct RppLrNthw *p, uint32_t val);
void RppLrNthw_RcpCnt(const struct RppLrNthw *p, uint32_t val);
void RppLrNthw_RcpExp(const struct RppLrNthw *p, uint32_t val);
void RppLrNthw_RcpFlush(const struct RppLrNthw *p);

/* RCP IFR */
void RppLrNthw_IfrRcpSelect(const struct RppLrNthw *p, uint32_t val);
void RppLrNthw_IfrRcpCnt(const struct RppLrNthw *p, uint32_t val);
void RppLrNthw_IfrRcpEn(const struct RppLrNthw *p, uint32_t val);
void RppLrNthw_IfrRcpMtu(const struct RppLrNthw *p, uint32_t val);
void RppLrNthw_IfrRcpFlush(const struct RppLrNthw *p);

#endif /* __FLOW_NTHW_RPP_LR_H__ */
