/* SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef __FLOW_NTHW_SLC_H__
#define __FLOW_NTHW_SLC_H__

#include <stdint.h> /* uint32_t */
#include "nthw_fpga_model.h"

struct SlcNthw {
  uint8_t mPhysicalAdapterNo;
  nthw_fpga_t *mpFpga;

  nthw_module_t *mSlc;

  nthw_register_t *mpRcpCtrl;
  nthw_field_t *mpRcpAddr;
  nthw_field_t *mpRcpCnt;
  nthw_register_t *mpRcpData;

  nthw_field_t *mpRcpDataTailSlcEn;
  nthw_field_t *mpRcpDataTailDyn;
  nthw_field_t *mpRcpDataTailOfs;
  nthw_field_t *mpRcpDataPcap;
};

typedef struct SlcNthw SlcNthw_t;
#if 0
typedef struct SlcNthw SlcNthw;
#endif

struct SlcNthw *SlcNthw_new(void);
void SlcNthw_delete(struct SlcNthw *p);
int SlcNthw_init(struct SlcNthw *p, nthw_fpga_t *pFpga, int nInstance);

int SlcNthw_setup(struct SlcNthw *p, int nIdx, int nIdxCnt);
void slcNthw_setDebugMode(struct SlcNthw *p, unsigned int nDebugMode);

#if 0
  uint32_t GetVersionMajor(void) {return (mSlc.getVersion()).getMajorVersion();}
  uint32_t GetVersionMinor(void) {return (mSlc.getVersion()).getMinorVersion();}
  void SetDebugOutput(int on) {if (on) mSlc.setDebugMode(Register::ON_WRITE); else mSlc.setDebugMode(Register::NO_DEBUG);}
#endif

/* RCP */
void SlcNthw_RcpSelect(const struct SlcNthw *p, uint32_t val);
void SlcNthw_RcpCnt(const struct SlcNthw *p, uint32_t val);
void SlcNthw_RcpTailSlcEn(const struct SlcNthw *p, uint32_t val);
void SlcNthw_RcpTailDyn(const struct SlcNthw *p, uint32_t val);
void SlcNthw_RcpTailOfs(const struct SlcNthw *p, int32_t val);
void SlcNthw_RcpPcap(const struct SlcNthw *p, uint32_t val);
void SlcNthw_RcpFlush(const struct SlcNthw *p);

#endif /* __FLOW_NTHW_SLC_H__ */
