/* SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef __NTHW_PLATFORM_DRV_H__
#define __NTHW_PLATFORM_DRV_H__

#include "nthw_helper.h"

#define NT_HW_PCI_VENDOR_ID        (0x18f4)
#define NT_HW_PCI_VENDOR_ID_LENOVO (0x17aa)

#define NT_HW_PCI_DEVICE_ID_NT40E3   (0x145)
#define NT_HW_PCI_DEVICE_ID_NT100E3  (0x155)
#define NT_HW_PCI_DEVICE_ID_NT80E3   (0x165)
#define NT_HW_PCI_DEVICE_ID_NT40A00  (0x175) /* ehrmmm bummer */
#define NT_HW_PCI_DEVICE_ID_NT40A01  (0x185)
#define NT_HW_PCI_DEVICE_ID_NT200E3  (0x195)
#define NT_HW_PCI_DEVICE_ID_NT200A01 (0x1A5)
#define NT_HW_PCI_DEVICE_ID_NT200D01 (0x1B5)
#define NT_HW_PCI_DEVICE_ID_NT200A02 (0x1C5)
#define NT_HW_PCI_DEVICE_ID_NT50B01  (0x1D5)
#define NT_HW_PCI_DEVICE_ID_NT100A01 (0x1E5)
#define NT_HW_PCI_DEVICE_ID_NT400D11 (0x215)

#define NT_HW_PCI_DEVICE_ID_NT200A02_LENOVO (0x05a1)
#define NT_HW_PCI_DEVICE_ID_NT50B01_LENOVO  (0x05b1)

enum NthwAdapterId_e
{
  NT_HW_ADAPTER_ID_UNKNOWN = 0,
  NT_HW_ADAPTER_ID_NT40E3,
  NT_HW_ADAPTER_ID_NT40A01 = NT_HW_ADAPTER_ID_NT40E3,
  NT_HW_ADAPTER_ID_NT50B01,
  NT_HW_ADAPTER_ID_NT80E3,
  NT_HW_ADAPTER_ID_NT100E3,
  NT_HW_ADAPTER_ID_NT100A01,
  NT_HW_ADAPTER_ID_NT200E3,
  NT_HW_ADAPTER_ID_NT200A01,
  NT_HW_ADAPTER_ID_NT200D01,
  NT_HW_ADAPTER_ID_NT200A02,
  NT_HW_ADAPTER_ID_NT400D11,
};

typedef enum NthwAdapterId_e NthwAdapterId_t;

#if 0
typedef uint32_t nthw_pciid_t;
#endif

NthwAdapterId_t NthwPlatform_GetNthwAdapterId(const uint16_t nPciDeviceId);

#endif  /* __NTHW_PLATFORM_DRV_H__ */
