/* SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef NTNIC_RELAY_H_
#define NTNIC_RELAY_H_

#include <rte_pci.h>

int dvio_relay_configure_txq(int vhid,
                             int queue_id,
                             struct hwq_s *hwq,
                             int num_descr);

int dvio_relay_configure_rxq(int vhid,
    int queue_id, struct hwq_s *hwq,
    int num_descr, int core_id, handle_t **handle);

void dvio_relay_execute(void *handle);

int dvio_relay_new_device(int vid, struct rte_pci_addr addr);
int dvio_relay_destroy_device(int vid);

int dvio_relay_create(int vhid,
    int queue_hw_id, int hw_port_id,
    int rxqs, int txqs,
    const char *socket_path);

#endif /*NTNIC_RELAY_H_ */
