/* SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2023 Napatech A/S
 */

#ifndef _NTAVR_H
#define _NTAVR_H

#include <stdint.h>
#include <stdlib.h>

#include "avr_intf.h"
#include "nthw_drv.h"
#include "nthw_spi_v3.h"

/*
 * @internal
 * @brief AVR Device Enum
 *
 * Global names for identifying an AVR device for Generation2 adapters
 */
enum ntavr_device {
  NTAVR_MAINBOARD,    /* Mainboard AVR device */
  NTAVR_FRONTBOARD    /* Frontboard AVR device */
};

int NtAvrSensorMonSetup(struct sensor_mon_setup16* pSetup, Nthw_Spi_V3_t *s_spi);
int NtAvrSensorMonCtrl(Nthw_Spi_V3_t *s_spi, enum sensor_mon_control ctrl);
uint32_t sensor_read(NthwSpis_t* t_spi, uint8_t fpgaIdx, uint32_t *pSensorResult);

#endif /* _NTAVR_H */
