/*-
 *   BSD LICENSE
 *
 *   Copyright(c) 2010-2015 Intel Corporation. All rights reserved.
 *   All rights reserved.
 *
 *   Redistribution and use in source and binary forms, with or without
 *   modification, are permitted provided that the following conditions
 *   are met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in
 *       the documentation and/or other materials provided with the
 *       distribution.
 *     * Neither the name of Intel Corporation nor the names of its
 *       contributors may be used to endorse or promote products derived
 *       from this software without specific prior written permission.
 *
 *   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 *   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 *   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 *   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 *   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 *   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef VIPER_FILTER_TEST_METER_SETUP_H
#define VIPER_FILTER_TEST_METER_SETUP_H

#include <rte_mtr.h>

#include "utils.h"

#define MTR_ID_UL 0
#define MTR_ID_FIRST_COMMON (MTR_ID_UL+1)
#define MAX_POLICY_PER_FLOW 2
#define START_UNIQUE_METER_ID (MTR_ID_FIRST_COMMON + MAX_POLICY_PER_FLOW)

struct meter_context_s {
  struct rte_mtr_meter_profile       profile;
  struct rte_mtr_meter_policy_params policy;

  uint32_t id;
  uint8_t port_id;
};

int meter_handle_create(struct meter_context_s *context,
  uint8_t port_id, uint32_t id, uint64_t rate, uint64_t size);

int meter_handle_destroy(struct meter_context_s *context);

int meter_learn(struct meter_context_s *context, uint32_t mtr_id, uint64_t stats_mask);

int meter_unlearn(struct meter_context_s *context, uint32_t mtr_id);

#endif  // VIPER_FILTER_TEST_METER_SETUP_H
