#ifndef INLINE_UPF_DEMO_PRE_LEARN_H
#define INLINE_UPF_DEMO_PRE_LEARN_H


#define _unused __attribute__((__unused__))

#define USE_MTR_COUNT_LOCK 1
#define DONT_USE_MTR_COUNT_LOCK 0
#define MAX_PORT_NUMBER 2
#define MAX_POLICY_PER_FLOW 2

#define DEFAULT_PIR (100UL * ((1000UL * 1000UL * 1000UL) / 8UL)) // 100 Gbps
#define DEFAULT_PBS  ((uint64_t)(4UL*1000UL*1000UL))

extern int policy_per_flow;
extern bool unique_policy_per_flow_en;
extern uint64_t port_pir_value[MAX_PORT_NUMBER];
extern uint64_t port_pbs_value[MAX_PORT_NUMBER];
extern uint64_t flow_meter_policy_PIR[MAX_POLICY_PER_FLOW];
extern uint64_t flow_meter_policy_PBS[MAX_POLICY_PER_FLOW];
extern int flow_meter_policy;

struct packet_fields {
  uint16_t ether_type;
  uint8_t protocol;
  uint32_t match_ipv4_src;
  uint32_t match_ipv4_dst;
  uint8_t match_ipv6_src[16];
  uint8_t match_ipv6_dst[16];
  uint16_t match_udp_src;
  uint16_t match_udp_dst;
  uint32_t encap_gtp_teid;
  uint8_t inner_proto;
  uint32_t match_ipv4_src_inner;
  uint32_t match_ipv4_dst_inner;
  uint8_t match_ipv6_src_inner[16];
  uint8_t match_ipv6_dst_inner[16];
  uint16_t match_udp_src_inner;
  uint16_t match_udp_dst_inner;
};

int parse_pcap(char *file_name, bool verbose, bool do_nat);
int remove_pre_learn_flows(void);
void dump_decoded_packet(struct packet_fields *fields);
int packet_decoder(const uint8_t *data, struct packet_fields *fields);
int get_meter_ids(int use_lock, uint32_t *meter_id_arr);
void setup_meters(void);
void destroy_meters(void);

#endif
