#!/usr/bin/env bash

NT_PF_NUM_ARRAY=($NT_PF_NUM)
NT_PF_DEV_ARRAY=($NT_PF_DEV)

DPDK_ARGS=${DpdkArgs}
APP_ARGS=${AppArgs}
APP_BIN="dpdk-inline_upf_demo"
APP_CPU="1-4"
VF_TOKEN="$(uuidgen)"


if [ "$NT_PF_DEV" != "" ] ; then
        #
        # 'inline_test' app will be executed
        #
        echo "POD Configuration from Napatech Device Plugin for resource 'napatech.com/nt_pf: 1"
        echo "  NT_PF_DEV =       $NT_PF_DEV"
        echo "  VF_TOKEN =        $VF_TOKEN"
        echo "Configuration from configmap napatech-inline-upf-demo-config:"
        echo "  DpdkArgs  =       ${DpdkArgs}"
        echo "  AppArgs   =       ${AppArgs}"
        DPDK_ARGS="${DPDK_ARGS} --vfio-vf-token=${VF_TOKEN} -a ${NT_PF_DEV_ARRAY[0]}"
else
        echo "ERROR: configuration from Napatech Device Plugin is not available."
        exit 1
fi

# Command line
cmd="${APP_BIN} -l ${APP_CPU} -n 4 --file-prefix=${NT_DPDK_PREFIX} ${DPDK_ARGS} -- ${APP_ARGS}"

# Call the command
echo "Executing: ${cmd}"
${cmd}
